(* open Flight;; *)

let _ =
  let v =
    Array.init Flight.nodes (fun i -> Flight.nodes * i + Flight.local)
  in
  for i = 0 to Flight.nodes - 1 do
    let r =
      Flight.env_buffer := [];
      begin
        Flight.save_closure
          (Marshal.to_string (fun () -> v.(i)) [Marshal.Closures]);
        let ___fun_sync () =
          if Flight.local == 0 then
            if i == Flight.local then v.(i) else Flight.drequest i 1
          else v.(i)
        in
        match Flight.sync_type.(0), Flight.sync_type.(1) with
          0, 0 ->
            Flight.begin_sync 1;
            let ___res_sync =
              try ___fun_sync () with
                Flight.RemoteExn e -> raise e
              | e -> raise e
            in
            Flight.end_sync (); ___res_sync
        | ___s, ___g ->
            if ___s == 1 && ___g == 0 || ___g == 1 then ___fun_sync ()
            else raise Flight.NestedSync
      end
    in
    v.(i) <- r
  done;
  Printf.printf "Processus %d: valeur du tableau: " Flight.local;
  flush stdout;
  for i = 0 to Flight.nodes - 1 do
    Printf.printf "%d " v.(i); flush stdout
  done;
  Printf.printf "\n";
  flush stdout

let _ = Flight.close_Flight ()





